/******************Example 7.2****************/

options ls = 80;

data d1;
infile '\T7_1_Example7_2.txt' firstobs = 2;
input obs y x1 x2;
run;

proc print;
run;

proc reg;
model y = x1;
run;

proc reg;
model y = x2;
run;

proc reg;
model y = x1 x2;
run;


/*************using proc iml******************/

proc iml;
use d1;

read all var{y} into y;
read all var{x1} into x1;
read all var{x2} into x2;
read all var{x1 x2} into xold;

reset print;

n = nrow(y);

x = j(n,1)||xold;

x1 = j(n,1)||x1;

x2 = j(n,1)||x2;

bhat1 = inv(x1`*x1)*x1`*y;

bhat2 = inv(x2`*x2)*x2`*y;

bhat = inv(x`*x)*x`*y;



/*******************Example 7.3.1(a)****************/

print 'Example 7.3.1(a):';

y = y;

x = x;

xpx = x`*x;

xpy = x`*y;

invxpx = inv(x`*x);

bhat = bhat;


/********************Example 7.3.3******************/

print 'Example 7.3.3:';

sse = y`*y - bhat`*x`*y;

k = 2;

s2 = sse/(n-k-1);



/*********************Example 7.5*******************/

print 'Example 7.5:';

xc = (i(n)-(1/n)*j(n,n))*xold;

sxx = xc`*xc/(n-1);

syx = xc`*y/(n-1);

b1hat = inv(sxx)*syx;

ybar = y`*j(n,1)/n;

xbar = xold`*j(n,1)/n;

b0hat = ybar - syx`*inv(sxx)*xbar;



/********************Example 7.7*******************/

print 'Example 7.7:';

r2 = (bhat`*x`*y - n*ybar##2)/(y`*y - n*ybar##2);

r2a = ((n-1)*r2 - k)/(n-k-1);
