/*************** Example 8.4.1(b) *****************/


data d1;

infile '\T7_4_ChemReaction.txt' firstobs = 2;
input x1 x2 x3 y1 y2;
run;


proc iml;
use d1;

reset print;

read all var{y1} into y1;
read all var{y2} into y2;
read all var{x1 x2 x3} into xold;
read all var{x1} into x1;
read all var{x2} into x2;
read all var{x3} into x3;

y = y1;

x = j(nrow(xold),1)||xold;

bhat = inv(x`*x)*x`*y;

c = {0 1 -1 0,
     0 0 2 -1};

cbhat = c*bhat;

cxpxc = c*inv(x`*x)*c`;

ypy = y`*y;
bxy = bhat`*x`*y;
n = nrow(x);

ybar = (j(n,1))`*y/n;

nybarsq = n*ybar*ybar;

sse = ypy - bxy;
k = ncol(xold);

num = cbhat`*inv(cxpxc)*cbhat;

f = (num/2)/(sse/(n-k-1));

pf = 1 - probf(f,2,n-k-1);
