/****************** Problem 7.51 ****************/

options ls = 80;

data d1;
infile '\T7_3_Gasvapor.txt' firstobs = 2;
input x1 x2 x3 x4 y;
run;

proc print;
run;

proc reg;
model y = x1 x2 x3 x4;
run;


/******************* Part A *********************/

proc iml;
use d1;

read all var{y} into y;
read all var{x1 x2 x3 x4} into xold;

reset print;

n = nrow(y);

x = j(n,1)||xold;

bhat = inv(x`*x)*x`*y;

sse = y`*y - bhat`*x`*y;

k = ncol(xold);

s2 = sse/(n-k-1);



/****************** Part B **********************/

print 'Part B:';

s2invxpx = s2*inv(x`*x);



/****************** Part C **********************/

print 'Part C:';

xc = (i(n)-(1/n)*j(n,n))*xold;

sxx = xc`*xc/(n-1);

syx = xc`*y/(n-1);

b1hat = inv(sxx)*syx;

ybar = y`*j(n,1)/n;

xbar = xold`*j(n,1)/n;

b0hat = ybar - syx`*inv(sxx)*xbar;



/******************** Part D ********************/

print 'Part D:';

r2 = (bhat`*x`*y - n*ybar##2)/(y`*y - n*ybar##2);

r2a = ((n-1)*r2 - k)/(n-k-1);
