/****************** Problem 7.52 ****************/

options ls = 80;

data d1;
infile '\T7_4_ChemReaction.txt' firstobs = 2;
input x1 x2 x3 y1 y2;
run;

proc print;
run;

proc reg;
model y1 = x1 x2 x3;
run;


/******************* Part A *********************/

proc iml;
use d1;

read all var{y1} into y;
read all var{x1} into x1;
read all var{x2} into x2;
read all var{x3} into x3;
read all var{x1 x2 x3} into xold;

reset print;

n = nrow(y);

x = j(n,1)||xold;

bhat = inv(x`*x)*x`*y;

sse = y`*y - bhat`*x`*y;

k = ncol(xold);

s2 = sse/(n-k-1);



/****************** Part B **********************/

print 'Part B:';

s2invxpx = s2*inv(x`*x);



/****************** Part C **********************/

print 'Part C:';

xc = (i(n)-(1/n)*j(n,n))*xold;

sxx = xc`*xc/(n-1);

syx = xc`*y/(n-1);

b1hat = inv(sxx)*syx;

ybar = y`*j(n,1)/n;

xbar = xold`*j(n,1)/n;

b0hat = ybar - syx`*inv(sxx)*xbar;

r2 = (bhat`*x`*y - n*ybar##2)/(y`*y - n*ybar##2);

r2a = ((n-1)*r2 - k)/(n-k-1);



/******************** Part D *******************/

print 'Part D:';

x1sq = x1#x1;
x2sq = x2#x2;
x3sq = x3#x3;

x1x2 = x1#x2;
x1x3 = x1#x3;
x2x3 = x2#x3;

xadd = x1sq||x2sq||x3sq||x1x2||x1x3||x2x3;

x = j(n,1)||xold||xadd;

bhat = inv(x`*x)*x`*y;

sse = y`*y - bhat`*x`*y;

k = ncol(x)-1;

s2 = sse/(n-k-1);



/********************* Part E *****************/

print 'Part E:';

xc = (i(n)-(1/n)*j(n,n))*(xold||xadd);

sxx = xc`*xc/(n-1);

syx = xc`*y/(n-1);

b1hat = inv(sxx)*syx;

ybar = y`*j(n,1)/n;

xbar = (xold||xadd)`*j(n,1)/n;

b0hat = ybar - syx`*inv(sxx)*xbar;

r2 = (bhat`*x`*y - n*ybar##2)/(y`*y - n*ybar##2);

r2a = ((n-1)*r2 - k)/(n-k-1);
