/************** Problem 8.39 *********************/

data d1;
infile '\T7_5_LandRent.txt' firstobs = 2;
input y x1 x2 x3;
run;

proc iml;
use d1;

reset print;

read all var{x1 x2 x3} into xold;
read all var{y} into y;
read all var{x1} into x1;
read all var{x2} into x2;
read all var{x3} into x3;

x = j(nrow(xold),1)||xold;

bhat = inv(x`*x)*x`*y;
s2 = (y-x*bhat)`*(y-x*bhat)/(nrow(x)-ncol(x));

covbhat = s2*inv(x`*x);

n = nrow(xold);

xc = (i(n)-(1/n)*j(n))*xold;

Sxx = xc`*xc/(n-1);

Syx = xc`*y/(n-1);

b1hat = inv(Sxx)*Syx;

ybar = y`*j(n,1)/n;

xbar = ((j(n,1))`*xold/n)`;

bnot = ybar - Syx`*inv(Sxx)*xbar;

r2 = (bhat`*x`*y - n*ybar*ybar)/(y`*y-n*ybar*ybar);

k = ncol(xold);

r2a = ((n-1)*r2 - k)/(n-k-1);

ybar = (j(n,1))`*y/n;

nybarsq = n*ybar*ybar;

bxy = bhat`*x`*y;

yy = y`*y;

diff = bxy - nybarsq;
ssr = bxy - nybarsq;
sse = yy - bxy;
k = ncol(xold);
f = (ssr/k)/(sse/(n-k-1));

pf = 1 - probf(f,k,n-k-1);



/********************** Part B ********************/

print 'Part B:';

xtest = x2||x3;

x11 = j(nrow(xold),1)||xtest;

b1star = inv(x11`*x11)*x11`*y;

diff1 = b1star`*x11`*y - nybarsq;
diff2 = bxy - b1star`*x11`*y;
p = ncol(x11);
h = ncol(x) - p;
fhere = (diff2/h)/(sse/(n-k-1));

ffhere = 1 - probf(fhere,2,27);


df = n - k - 1;
t975 = tinv(.975,df);


s = sqrt(s2);

invxpx = inv(x`*x);
b0 = bhat[1];
b1 = bhat[2];
b2 = bhat[3];
b3 = bhat[4];

g00 = invxpx[1,1];
g11 = invxpx[2,2];
g22 = invxpx[3,3];
g33 = invxpx[4,4];


ssg1 = s*sqrt(g11);
t1 = b1/ssg1;
p1 = 2*(1-probt(t1,df));

ssg2 = s*sqrt(g22);
t2 = b2/ssg2;
p2 = 2*(1-probt(t2,df));

ssg3 = s*sqrt(g33);
t3 = b3/ssg3;
p3 = 2*(probt(t3,df));



/********************** Part C ********************/

print 'Part C:';

print 'confidence limits';
b1me = t975*s*sqrt(g11);
b1lo = b1 - b1me;
b1up = b1 + b1me;

print 'confidence limits';
b2me = t975*s*sqrt(g22);
b2lo = b2 - b2me;
b2up = b2 + b2me;

print 'confidence limits';
b3me = t975*s*sqrt(g33);
b3lo = b3 - b3me;
b3up = b3 + b3me;



thelp = 1 - .008333333;


t975div = tinv(thelp,df);

print 'bonferroni confidence limits';
b1me = t975div*s*sqrt(g11);
b1lo = b1 - b1me;
b1up = b1 + b1me;

print 'bonferroni confidence limits';
b2me = t975div*s*sqrt(g22);
b2lo = b2 - b2me;
b2up = b2 + b2me;

print 'bonferroni confidence limits';
b3me = t975div*s*sqrt(g33);
b3lo = b3 - b3me;
b3up = b3 + b3me;


/******************* Part D *******************/

print 'Part D:';

t975 = tinv(.975,df);

xbar = ((j(n,1))`*x/n)`;

x0 = {1,15,30,.5};

x0bhat = x0`*bhat;

invxpx = inv(x`*x);

sqrt = sqrt(x0`*invxpx*x0);

me = t975*s*sqrt;

lo = x0bhat - me;
up = x0bhat + me;



/******************* Part E *******************/

print 'Part E:';

t975 = tinv(.975,df);

xbar = ((j(n,1))`*x/n)`;

x0 = {1,15,30,.5};

x0bhat = x0`*bhat;

invxpx = inv(x`*x);

sqrt = sqrt(1+x0`*invxpx*x0);

me = t975*s*sqrt;

lo = x0bhat - me;
up = x0bhat + me;
