/*************** Problem 8.41 ***********************/


options ls = 80;

data d1;
infile '\T7_4_ChemReaction.txt' firstobs = 2;
input x1 x2 x3 y1 y2;
run;



proc iml;
use d1;

/******************* Part A *************************/

reset print;

read all var{y1} into y1;
read all var{y2} into y2;
read all var{x1 x2 x3} into xold;
read all var{x1} into x1;
read all var{x2} into x2;
read all var{x3} into x3;

y = y1;

x1x1 = x1#x1;
x2x2 = x2#x2;
x3x3 = x3#x3;
x1x2 = x1#x2;
x1x3 = x1#x3;
x2x3 = x2#x3;

xadd = x1x1||x2x2||x3x3||x1x2||x1x3||x2x3;

x = j(nrow(xold),1)||xold||xadd;

xy = x`*y;
bhat = inv(x`*x)*x`*y;
yy = y`*y;
bxy = bhat`*x`*y;
n = nrow(x);

invxpx = inv(x`*x);

t975 = tinv(.975,15);

s2 = (y-x*bhat)`*(y-x*bhat)/(nrow(x)-ncol(x));
s = sqrt(s2);

invxpx = inv(x`*x);

ybar = (j(n,1))`*y/n;

nybarsq = n*ybar*ybar;

diff = bxy - nybarsq;
ssr = bxy - nybarsq;
sse = yy - bxy;
k = ncol(xold);
f = (ssr/k)/(sse/(n-k-1));

x11 = j(nrow(xold),1)||xold;

b1star = inv(x11`*x11)*x11`*y;

bstarxy = b1star`*x11`*y;

diff1 = b1star`*x11`*y - nybarsq;
diff2 = bxy - b1star`*x11`*y;

h = ncol(x) - k - 1;
fhere = (diff2/h)/(sse/(n-9-1));

pF =1 - probf(1.1026,6,9);


/**************** Part B *************************/

print 'Part B:';

r2 = (bhat`*x`*y - n*ybar*ybar)/(y`*y - n*ybar*ybar);

r2r = (b1star`*x11`*y - n*ybar*ybar)/(y`*y - n*ybar*ybar);

F = ((r2 - r2r)/h)/((1 - r2)/(n - ncol(x)));



/***************** Part C ************************/

print 'Part C:';

x = j(nrow(xold),1)||xold;

xy = x`*y;
bhat = inv(x`*x)*x`*y;
yy = y`*y;
bxy = bhat`*x`*y;
n = nrow(x);

invxpx = inv(x`*x);

t975 = tinv(.975,15);

s2 = (y-x*bhat)`*(y-x*bhat)/(nrow(x)-ncol(x));
s = sqrt(s2);

b0 = bhat[1];
b1 = bhat[2];
b2 = bhat[3];
b3 = bhat[4];
g00 = invxpx[1,1];
g11 = invxpx[2,2];
g22 = invxpx[3,3];
g33 = invxpx[4,4];

print 'confidence limits';
b0me = t975*s*sqrt(g00);
b0lo = b0 - b0me;
b0up = b0 + b0me;

print 'confidence limits';
b1me = t975*s*sqrt(g11);
b1lo = b1 - b1me;
b1up = b1 + b1me;

print 'confidence limits';
b2me = t975*s*sqrt(g22);
b2lo = b2 - b2me;
b2up = b2 + b2me;

print 'confidence limits';
b3me = t975*s*sqrt(g33);
b3lo = b3 - b3me;
b3up = b3 + b3me;


/***************** Part D ************************/

print 'Part D:';

thelp = 1 - .008333333;


t975div = tinv(.9916667,15);

print 'bonferroni confidence limits';
b1me = t975div*s*sqrt(g11);
b1lo = b1 - b1me;
b1up = b1 + b1me;

print 'bonferroni confidence limits';
b2me = t975div*s*sqrt(g22);
b2lo = b2 - b2me;
b2up = b2 + b2me;

print 'bonferroni confidence limits';
b3me = t975div*s*sqrt(g33);
b3lo = b3 - b3me;
b3up = b3 + b3me;


/***************** Part E ************************/

print 'Part E:';

t975 = tinv(.975,df);

xbar = ((j(n,1))`*x/n)`;

s = s;

x0 = {1,165,32,5};

x0bhat = x0`*bhat;

invxpx = inv(x`*x);

sq = x0`*invxpx*x0;

sqrt = sqrt(x0`*invxpx*x0);

me = t975*s*sqrt;

lo = x0bhat - me;
up = x0bhat + me;



/***************** Part F ************************/

print 'Part F:';

t975 = tinv(.975,df);

xbar = ((j(n,1))`*x/n)`;

s = s;

x0 = {1,165,32,5};

x0bhat = x0`*bhat;

invxpx = inv(x`*x);

sq = 1 + x0`*invxpx*x0;

sqrt = sqrt(1 + x0`*invxpx*x0);

me = t975*s*sqrt;

lo = x0bhat - me;
up = x0bhat + me;
