options ls=80;

data data;
infile '\T10_1_HematologySplit.txt' firstobs=2 ;
input x1 x2 x3 y1 x4 x5 x21 x22 x23 y2 x24 x25;
run;

/************ Example 10.4b **************/

proc iml;

print 'x1 = hemo, x21 = hemo2';
print 'x2 = pcv, x22 = pcv2';
print 'x3 = wbc, x23 = wbc2';
print 'y1 = lympho, y2 = lympho2';
print 'x4 = neutro, x24 = neutro2';
print 'x5 = lead, x25 = lead2';

n1 = 26;
r1 = .4993996;
z1 = (.5) * log((1 + r1) / (1 - r1));
print z1;

n11 = 25;
r11 = .04242641;
z2 = (.5) * log((1 + r11) / (1 - r11));
print z2;

v = (z1 - z2) / ((1/(n1-3) + 1/(n11-3))##.5);
print 'v from (10.55):';
print v;

print 'table z for z(.05/2):';
z_25 = 1.96;
print z_25;

x_low1 = z1 - z_25/((n1-3)##.5);
x_hi1 =  z1 + z_25/((n1-3)##.5);


tanhxlo1 = (exp(x_low1) - exp(-x_low1))/((exp(x_low1) + exp(-x_low1)));
tanhxhi1 = (exp(x_hi1) - exp(-x_hi1))/((exp(x_hi1) + exp(-x_hi1)));
print 'The lower and upper confidence limits';
print 'for rho for r1 in (10.57) are:';
print tanhxlo1;
print tanhxhi1;

x_low11 = z2 - z_25/((n11-3)##.5);
x_hi11 =  z2 + z_25/((n11-3)##.5);

tanlo11 = (exp(x_low11) - exp(-x_low11))/((exp(x_low11) + exp(-x_low11)));
tanhi11 = (exp(x_hi11) - exp(-x_hi11))/((exp(x_hi11) + exp(-x_hi11)));
print 'The lower and upper confidence limits';
print 'for rho for r11 in (10.57) are:';
print tanlo11;
print tanhi11;

quit;
