/********************Example 6.2*****************/

options ls = 80;

data d1;
infile '\exam.txt' firstobs = 2;
input y x;
run;

proc print;
run;

proc iml;
use d1;

read all var{y} into y;
read all var{x} into x;

reset print;

n = nrow(y);

ybar = y`*j(n,1)/n;

xbar = x`*j(n,1)/n;

sumxy = x`*y;

sumxx = x`*x;

b1 = (sumxy - n*xbar*ybar)/(sumxx - n*(xbar##2));

b0 = ybar - b1*xbar;

print 'end example 6.2';

/********************Example 6.3*****************/

print 'Example 6.3:';

sse = (y - b0*j(n,1) - b1*x)`*(y - b0*j(n,1) - b1*x);

s2 = sse/(n-2);

s = sqrt(s2);

sumxxbar = (x-xbar*j(n,1))`*(x-xbar*j(n,1));

t = b1/(s/sqrt(sumxxbar));

t025_16 = tinv(.975,n-2);

pt = 2*(1 - probt(t,n-2));

/***************Confidence Interval for B1 *************/

upper = b1 + t025_16*s/sqrt(sumxxbar);

lower = b1 - t025_16*s/sqrt(sumxxbar);

print 'end of example 6.3';


/**********************Example 6.4***************/

print 'Example 6.4:';

yhat = b0*j(n,1) + b1*x;

ssr = (yhat - ybar*j(n,1))`*(yhat - ybar*j(n,1));

sst = (y - ybar*j(n,1))`*(y - ybar*j(n,1));

r2 = ssr/sst;

r = sqrt(r2);


run;
