/*************** Example 8.2(a) *****************/


data d1;

infile '\T7_4_ChemReaction.txt' firstobs = 2;
input x1 x2 x3 y1 y2;
run;


proc iml;
use d1;

reset print;

read all var{y1} into y1;
read all var{y2} into y2;
read all var{x1 x2 x3} into xold;
read all var{x1} into x1;
read all var{x2} into x2;
read all var{x3} into x3;

y = y2;

x1x1 = x1#x1;
x2x2 = x2#x2;
x3x3 = x3#x3;
x1x2 = x1#x2;
x1x3 = x1#x3;
x2x3 = x2#x3;

xadd = x1x1||x2x2||x3x3||x1x2||x1x3||x2x3;

x = j(nrow(xold),1)||xold||xadd;

xy = x`*y;
bhat = inv(x`*x)*x`*y;
yy = y`*y;
bxy = bhat`*x`*y;
n = nrow(x);

ybar = (j(n,1))`*y/n;

nybarsq = n*ybar*ybar;

diff = bxy - nybarsq;
ssr = bxy - nybarsq;
sse = yy - bxy;
k = ncol(xold);
f = (ssr/k)/(sse/(n-k-1));

x11 = j(nrow(xold),1)||xold;

b1star = inv(x11`*x11)*x11`*y;

diff1 = b1star`*x11`*y - nybarsq;
diff2 = bxy - b1star`*x11`*y;

h = ncol(x) - k - 1;
fhere = (diff2/h)/(sse/(n-9-1));

pfhere = 1 - probf(fhere,ncol(x)-k-1,n-9-1);



/******* Overall F for reduced model *******/

ssered = yy - b1star`*x11`*y;

fred = (diff1/3)/(ssered/(n-3-1));

pfred = 1 - probf(fred,3,n-3-1);


/******* Overall F for full model **********/

ffull = (ssr/9)/(sse/(n-9-1));

pffull = 1 - probf(ffull,9,n-9-1);



/**************** Example 8.3(a) ****************/

print 'Example 8.3(a):';

r2 = (bxy - nybarsq)/(yy - nybarsq);

r2a = (b1star`*x11`*y - nybarsq)/(yy - nybarsq);


fr = ((r2 - r2a)/h)/((1 - r2)/(n-9-1));
