/**************** Example 8.6.2(a) ************/


data d1;

infile '\T7_4_ChemReaction.txt' firstobs = 2;
input x1 x2 x3 y1 y2;
run;

proc iml;
use d1;

reset print;

read all var{y1} into y1;
read all var{y2} into y2;
read all var{x1 x2 x3} into xold;
read all var{x1} into x1;
read all var{x2} into x2;
read all var{x3} into x3;

y = y2;

x = j(nrow(xold),1)||xold;

xy = x`*y;
bhat = inv(x`*x)*x`*y;
yy = y`*y;
bxy = bhat`*x`*y;
n = nrow(x);

invxpx = inv(x`*x);

t975 = tinv(.975,15);

s2 = (y-x*bhat)`*(y-x*bhat)/(nrow(x)-ncol(x));
s = sqrt(s2);

invxpx = inv(x`*x);
b0 = bhat[1];
b1 = bhat[2];
b2 = bhat[3];
b3 = bhat[4];
g00 = invxpx[1,1];
g11 = invxpx[2,2];
g22 = invxpx[3,3];
g33 = invxpx[4,4];

print 'confidence limits';
b0me = t975*s*sqrt(g00);
b0lo = b0 - b0me;
b0up = b0 + b0me;

print 'confidence limits';
b1me = t975*s*sqrt(g11);
b1lo = b1 - b1me;
b1up = b1 + b1me;

print 'confidence limits';
b2me = t975*s*sqrt(g22);
b2lo = b2 - b2me;
b2up = b2 + b2me;

print 'confidence limits';
b3me = t975*s*sqrt(g33);
b3lo = b3 - b3me;
b3up = b3 + b3me;


/************** Example 8.6.7(d) ***************/


thelp = 1 - .008333333;

t975div = tinv(.9916667,15);

print 'bonferroni confidence limits';
b1me = t975div*s*sqrt(g11);
b1lo = b1 - b1me;
b1up = b1 + b1me;

print 'bonferroni confidence limits';
b2me = t975div*s*sqrt(g22);
b2lo = b2 - b2me;
b2up = b2 + b2me;

print 'bonferroni confidence limits';
b3me = t975div*s*sqrt(g33);
b3lo = b3 - b3me;
b3up = b3 + b3me;
