options ls=80;

data data;
infile '\T10_2_rat.txt' firstobs=2;
input x1 x2 x3 y;
run;

/*************** Problem 10.30 ****************/

proc iml;
use data;
read all var {x1 x2 x3} into x;
read all var {y} into y;

n = nrow(x);
k = ncol(x);
x_center = (i(n) - (1/n)*j(n,n)) * x;
xbar = (1/n) * x` * j(n,1);
ybar = (1/n) * y` * j(n,1);

Sxx = (x_center` * x_center) / (n-1);
syx = (x_center` * y) / (n-1);
sxy = syx`;

beta1 = inv(Sxx) * syx;
beta0 = ybar - syx` * inv(Sxx) * xbar;

*print Sxx;
*print syx;
*print sxy;

*print 'beta1 as in (10.15):';
*print beta1;
*print 'beta0 as in (10.16):';
*print beta0;

syy = (y - ybar)`*(y - ybar) / (n - 1);

*print syy;


s2 = syy - syx` * inv(Sxx) * syx;
*print 's2 as in (10.17):';
*print s2;

spart1 = syx||Sxx;
spart2 = syy||sxy;
S = spart2//spart1;
print S;

/*** part a ***/

Sy1 = S[1:2,1:2];
print Sy1;

Syx1 = S[1:2,3:4];
Sxy1 = S[3:4,1:2];
Sxx1 = S[3:4,3:4];

Ds1 = (diag(Sy1 - Syx1*inv(Sxx1)*Sxy1))##.5;
print Ds1;
print 'ry1.23 comes from:';
ry1_23 = inv(Ds1)*(Sy1 - Syx1*inv(Sxx1)*Sxy1)*inv(Ds1);
print ry1_23;

/*** part b ***/

Sy2 = S[{1 3},{1 3}];
print Sy2;

Syx2 = S[{1 3},{2 4}];
Sxy2 = S[{2 4},{1 3}];
Sxx2 = S[{2 4},{2 4}];

Ds2 = (diag(Sy2 - Syx2*inv(Sxx2)*Sxy2))##.5;
print Ds2;
print 'ry2.13 comes from:';
ry2_13 = inv(Ds2)*(Sy2 - Syx2*inv(Sxx2)*Sxy2)*inv(Ds2);
print ry2_13;

/*** part c ***/

Sy3 = S[{1 2 3},{1 2 3}];
print Sy3;

Syx3 = S[{1 2 3},{4}];
Sxy3 = S[{4},{1 2 3}];
Sxx3 = S[{4},{4}];

Ds3 = (diag(Sy3 - Syx3*inv(Sxx3)*Sxy3))##.5;
print Ds3;
print 'ry.x comes from:';
ry_x = inv(Ds3)*(Sy3 - Syx3*inv(Sxx3)*Sxy3)*inv(Ds3);
print ry_x;

quit;
