options ls = 80;

data d1;
infile '\T14_9_RatProtein.txt' firstobs=2;
input level source wtgain;
run;

/*** part a ***/

proc iml;
use d1;
read all var{wtgain} into y;
w1 = {1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
w2 = {0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
w3 = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
w4 = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,
1,1,0,0,0,0,0,0,0,0,0,0,0,0,0};
w5 = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,1,1,1,1,1,1,0,0,0,0,0,0,0};
w6 = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,1,1,1,1,1,1,1};
W = w1||w2||w3||w4||w5||w6;
n = nrow(W);
ab = ncol(W);
ybar = (inv(W`*W))*W`*y;
a = {1,1,1,-1,-1,-1};
b1 = {1 -2 1 1 -2 1};
b2 = {1 0 -1 1 0 -1};
B = b1//b2;
c1 = {1 -2 1 -1 2 -1};
c2 = {1 0 -1 -1 0 1};
C = c1//c2;
SSE = y`*(I(n)-W*(inv(W`*W))*W`)*y;
ve = n-ab;
vb = nrow(B);
vab = nrow(C);
s2 = SSE/ve;
FforA = ((a`*ybar)*(a`*ybar))/(s2*(a`*(inv(W`*W))*a));
FforB = ((B*ybar)`*(inv(B*(inv(W`*W))*B`))*B*ybar*ve)/(SSE*vb);
FforC = ((C*ybar)`*(inv(C*(inv(W`*W))*C`))*C*ybar*ve)/(SSE*vab);
pFforA = 1-probf(FforA,1,ve);
pFforB = 1-probf(FforB,vb,ve);
pFforC = 1-probf(FforC,vab,ve);
print n ab ybar a B C SSE ve vb vab s2;
print FforA FforB FforC;
print pFforA pFforB pFforC;

/*** part b ***/

k1 = {1 1 1 1 1 1};
k2 = {1 1 1 -1 -1 -1};
k3 = {1 -2 1 1 -2 1};
k4 = {1 0 -1 1 0 -1};
K = k1//k2//k3//k4;
G = C;
A1 = K//G;
Z = W*inv(A1);
Z1 = Z[,{1,2,3,4}];
ybarc = K`*(inv(K*K`))*(inv(Z1`*Z1))*Z1`*y;
vec = ve+2;
SSEc = (y-W*ybarc)`*(y-W*ybarc);
FforBc = ((B*ybarc)`*(inv(B*K`*(inv(K*K`))*(inv(Z1`*Z1))*(inv(K*K`))*K*B`))*B*ybarc*vec)/(vb*SSEc);
Fforac = ((a`*ybarc)`*(inv(a`*K`*(inv(K*K`))*(inv(Z1`*Z1))*(inv(K*K`))*K*a))*a`*ybarc*vec)/SSEc;
pFforBc = 1-probf(FforBc,vb,vec);
pFforac = 1-probf(Fforac,1,vec);


print K G A1 ybarc vec SSEc;
print Fforac FforBc;
print pFforac pFforBc;

quit;


/*** part c ***/

proc glm;
class level source;
model wtgain = level source level*source;
run;

proc glm;
class level source;
model wtgain = level source;
run;
