options ls=80;

data data;
infile '\T15_10_Auditory.txt' firstobs=2;
input gender trt pre post;
run;

proc iml;
use data;
read all var{gender} into gender;
read all var{trt} into group;
read all var{pre} into x;
read all var{post} into y;
;
;

print 'Table 15.5 elements';
c3=2;n3=10;a3=2;
*for SSAy a is treatment;
  za1 = {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
  za2 = {1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0};
  za3 = {0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1};
 ybar = (y`*za1)/(40);
 ybara1 = (y`*za2)/(20);
 ybara2 = (y`*za3)/(20);
 SSAy = c3*n3*((ybara1-ybar)*(ybara1-ybar)+(ybara2-ybar)*(ybara2-ybar));
print SSAy;

*for SSCy;
*c is gender;
  zc1 = {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
  zc2 = {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
  zc3 = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
 ybarc = (y`*zc1)/(a3*c3*n3);
 ybarc1 = (y`*zc2)/(a3*n3);
 ybarc2 = (y`*zc3)/(a3*n3);
SSCy = a3*n3*((ybarc1-ybarc)*(ybarc1-ybarc)+(ybarc2-ybarc)*(ybarc2-ybarc));
print SSCy;

*for SSACy;

  ac1 = {1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
  ac2 = {0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
  ac3 = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0};
  ac4 = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1};
 ftermy = (1/n3)*((y`*ac1)##2+(y`*ac2)##2+(y`*ac3)##2+(y`*ac4)##2);
 tot54y = ftermy-(((y`*za1)##2)/(a3*c3*n3));
SSACy = tot54y-SSAy-SSCy;
print SSACy;

*for SSAx and SPA;
 xbar = (x`*za1)/(a3*c3*n3);
 xbar2 = xbar##2;
 xbara1 = (x`*za2)/(a3*n3);
 xbara2 = (x`*za3)/(a3*n3);
SPA = (a3*n3)*((xbara1-xbar)*(ybara1-ybar)+(xbara2-xbar)*(ybara2-ybar));
SSAx = a3*n3*((xbara1-xbar)*(xbara1-xbar)+(xbara2-xbar)*(xbara2-xbar));
print SPA SSAx;

*for SSCx and SPC;
 xbarc = (x`*zc1)/(a3*c3*n3);
 xbarc1 = (x`*zc2)/(c3*n3);
 xbarc2 = (x`*zc3)/(c3*n3);
SPC = (c3*n3)*((xbarc1-xbarc)*(ybarc1-ybarc)+(xbarc2-xbarc)*(ybarc2-ybarc));
SSCx = c3*n3*((xbarc1-xbarc)*(xbarc1-xbarc)+(xbarc2-xbarc)*(xbarc2-xbarc));
print SPC SSCx;

*for SSACx;
ftermx = (1/n3)*((x`*ac1)##2+(x`*ac2)##2+(x`*ac3)##2+(x`*ac4)##2);
 tot55 = ftermx-(((x`*za1)##2)/(a3*c3*n3));
SSACx = tot55 - SSAx - SSCx;
print SSACx;

*for SPAC;
 ftermxy = (1/n3)*((x`*ac1)*(y`*ac1)+(x`*ac2)*(y`*ac2)+(x`*ac3)*(y`*ac3)
                +(x`*ac4)*(y`*ac4));
 tot56 = ftermxy - (((x`*za1)*(y`*za1))/(a3*c3*n3));
SPAC = tot56 - SPA - SPC;
print SPAC;


  z1 = {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
  z3 = {1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
  z3 = {0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
  z4 = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0};
  z5 = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1};

 Z = z1||z2||z3||z4||z5;
 P = Z*(ginv(Z`*Z))*Z`;
 n = nrow(Z);
SSEx = X`*(I(n)-P)*X;
SPE = X`*(I(n)-P)*y;
 B = (inv(SSEx))*SPE;
 a0 = (ginv(Z`*Z))*Z`*y;
 a = a0-(ginv(Z`*Z))*Z`*X*B;
SSEy = y`*y-a0`*Z`*y;


print 'y column:';
print SSAy SSCy SSACy SSEy;

print 'x column:';
print SSAx SSCx SSACx SSEx;

print 'xy column:';
print SPA SPC SPAC SPE;
print 'Sums of Squares for factors + error in table 15.5';
AEy = SSAy+SSEy;
CEy = SSCy+SSEy;
ACEy = SSACy+SSEy;

AEx = SSAx+SSEx;
CEx = SSCx+SSEx;
ACEx = SSACx+SSEx;

AExy = SPA+SPE;
CExy = SPC+SPE;
ACExy = SPAC+SPE;

print 'SSAy+SSEy:';
print AEy;

print 'SSCy+SSEy:';
print CEy;

print 'SSACy+SSEy:';
print ACEy;

print 'SSAx+SSEx:';
print AEx;

print 'SSCx+SSEx:';
print CEx;

print 'SSACx+SSEx:';
print ACEx;

print 'SPA+SPE:';
print AExy;

print 'SPC+SPE:';
print CExy;

print 'SPAC+SPE:';
print ACExy;

/****part b****/

;
 print 'SSAEyx (15.58):';
SSAEyx = SSAy+SSEy-((SPA+SPE)##2)/(SSAx+SSEx);
 print SSCEyx;

 print 'SSEyx (15.59):';
SSEyx = SSEy-(SPE##2)/SSEx;
 print SSEyx;

 print 'SSAyx (15.60):';
SSAyx = SSAEyx-SSEyx;
 print SSAyx;

 print 'test for main effect of A (15.61):';
Ffora = (SSayx*(a3*c3*(n3-1)-1))/(SSEyx*(a3-1));
 print Ffora;
p = 1-probf(Ffora,(a3-1),(a3*c3*(n3-1)-1));
print p;
;
 print 'SSCEyx (15.58):';
SSCEyx = SSCy+SSEy-((SPC+SPE)##2)/(SSCx+SSEx);
 print SSCEyx;

 print 'SSEyx (15.59):';
SSEyx = SSEy-(SPE##2)/SSEx;
 print SSEyx;

 print 'SSCyx (15.60):';
SSCyx = SSCEyx-SSEyx;
 print SSCyx;

 print 'test for main effect of C) (15.61):';
Fforc = (SSCyx*(a3*c3*(n3-1)-1))/(SSEyx*(c3-1));
 print Fforc;
p = 1-probf(Fforc,(c3-1),(a3*c3*(n3-1)-1));
print p;
;
 print 'SSACEyx (15.58):';
SSACEyx = SSACy+SSEy-((SPAC+SPE)##2)/(SSACx+SSEx);
 print SSCEyx;

 print 'SSEyx (15.59):';
SSEyx = SSEy-(SPE##2)/SSEx;
 print SSEyx;

 print 'SSACyx (15.60):';
SSACyx = SSACEyx-SSEyx;
 print SSACyx;

 print 'test for main effect of AC (15.61):';
Fforac = (SSACyx*(a3*c3*(n3-1)-1))/(SSEyx*((a3-1)*(c3-1)));
 print Fforac;
p = 1-probf(Fforac,(a3-1)*(c3-1),(a3*c3*(n3-1)-1));
print p;

/****part c****/

 print 'test for betas equal to zero (15.61):';
Fforb = (SPE##2*(a3*c3*(n3-1)-1))/(SSEyx*SSEx);
 print Fforb;
p = 1-probf(Fforb,1,(a3*c3*(n3-1)-1));
print p;

/****part d****/

*to test homogeneity of slope vectors;

/*** for level a ***/

y2a = y[{1 2 3 4 5 6 7 8 9 10 21 22 23 24 25 26 27 28 29 30},];
y1a = y[{11 12 13 14 15 16 17 18 19 20 31 32 33 34 35 36 37 38 39 40},];
x2a = x[{1 2 3 4 5 6 7 8 9 10 21 22 23 24 25 26 27 28 29 30},];
x1a = x[{11 12 13 14 15 16 17 18 19 20 31 32 33 34 35 36 37 38 39 40},];
 n=10;
 ;
*SSEx1;
;
ones1 = j(20,1,1);
ones2 = j(10,1,1);
zeros = j(10,1,0);
z11 = ones1`;
z21 = ones2`||zeros`;
z31 = zeros`||ones2`;
z1 = z11`||z21`||z31`;
p1 = z1*(ginv(z1`*z1))*z1`;
n1 = nrow(z1);
SSEx1 = x1a`*(I(n1)-p1)*x1a;
SPE1 = x1a`*(I(n1)-p1)*y1a;
b1 = (inv(SSEx1))*x1a`*(I(n1)-p1)*y1a;
a01 = (ginv(z1`*z1))*z1`*y1a;
a1 = a01 - (ginv(z1`*z1))*z1`*x1a*b1;
SSEy1 = y1a`*y1a - a01`*z1`*y1a;
;
*SSEx2;
;
SSEx2 = x2a`*(I(n1)-p1)*x2a;
SPE2 = x2a`*(I(n1)-p1)*y2a;
b2 = (inv(SSEx2))*x2a`*(I(n1)-p1)*y2a;
a01 = (ginv(z1`*z1))*z1`*y2a;
a1 = a01 - (ginv(z1`*z1))*z1`*x2a*b2;
SSEy2 = y2a`*y2a - a01`*z1`*y2a;
;
 print 'SSExi and SPEi for (15.64):';
 print SPE1 SPE2 SSEx1 SSEx2;
SSFull = SSEy - (SPE1##2/SSEx1+SPE2##2/SSEx2);
SSRed = SSEy - (SPE##2/SSEx);
SSdif = SSRed - SSFull;
numF = ((SPE1##2/SSEx1+SPE2##2/SSEx2)-(SPE##2/SSEx))/(a3-1);
denomF = (SSEy-(SPE1##2/SSEx1+SPE2##2/SSEx2))/(a3*c3*(n3-1)-a3);
Fbeta = numF/denomF;
 print SSFull;
 print SSRed;
 print 'SSRed-SSFull for (15.64):';
 print SSdif;
print 'Estimates of Betas:';
print B1 B2;
print 'F for homogeneity of slopes (15.64):';
print Fbeta;
p = 1-probf(Fbeta,(a3-1),(a3*c3*(n3-1)-a3));
print p;
;
/*** for level c ***/
;
*to test homogeneity of slope vectors;

y2c = y[{1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20},];
y1c = y[{21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40},];
x2c = x[{1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20},];
x1c = x[{21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40},];
 n=10;
;
*SSEx1;

ones1 = j(20,1,1);
ones2 = j(10,1,1);
zeros = j(10,1,0);
z11 = ones1`;
z21 = ones2`||zeros`;
z31 = zeros`||ones2`;
z1 = z11`||z21`||z31`;
p1 = z1*(ginv(z1`*z1))*z1`;
n1 = nrow(z1);
SSEx1 = x1c`*(I(n1)-p1)*x1c;
SPE1 = x1c`*(I(n1)-p1)*y1c;
b1 = (inv(SSEx1))*x1c`*(I(n1)-p1)*y1c;
a01 = (ginv(z1`*z1))*z1`*y1c;
a1 = a01 - (ginv(z1`*z1))*z1`*x1c*b1;
SSEy1 = y1c`*y1c - a01`*z1`*y1c;
;
*SSEx2;
;
SSEx2 = x2c`*(I(n1)-p1)*x2c;
SPE2 = x2c`*(I(n1)-p1)*y2c;
b2 = (inv(SSEx2))*x2c`*(I(n1)-p1)*y2c;
a01 = (ginv(z1`*z1))*z1`*y2c;
a1 = a01 - (ginv(z1`*z1))*z1`*x2c*b2;
SSEy2 = y2c`*y2c - a01`*z1`*y2c;


 print 'SSExi and SPEi for (15.64):';
 print SPE1 SPE2 SSEx1 SSEx2;
SSFull = SSEy - (SPE1##2/SSEx1+SPE2##2/SSEx2);
SSRed = SSEy - (SPE##2/SSEx);
SSdif = SSRed - SSFull;
numF = ((SPE1##2/SSEx1+SPE2##2/SSEx2)-(SPE##2/SSEx))/(a3-1);
denomF = (SSEy-(SPE1##2/SSEx1+SPE2##2/SSEx2))/(a3*c3*(n3-1)-a3);
Fbeta = numF/denomF;
 print SSFull;
 print SSRed;
 print 'SSRed-SSFull for (15.64):';
 print SSdif;
print 'Estimates of Betas:';
print B1 B2;
print 'F for homogeneity of slopes (15.64):';
print Fbeta;
p = 1-probf(Fbeta,(a3-1),(a3*c3*(n3-1)-a3));
print p;

quit;
