/********************Problem 6.14*****************/

options ls = 80;

data d1;
infile '\T6_1_Geyser.txt' firstobs = 2;
input y x;
run;

proc print;
run;

proc iml;
use d1;

read all var{y} into y;
read all var{x} into x;

reset print;

n = nrow(y);

ybar = y`*j(n,1)/n;

xbar = x`*j(n,1)/n;

sumxy = x`*y;

sumxx = x`*x;

b1 = (sumxy - n*xbar*ybar)/(sumxx - n*(xbar##2));

b0 = ybar - b1*xbar;


/******************* Part B *****************/

print 'Part B:';

sse = (y - b0*j(n,1) - b1*x)`*(y - b0*j(n,1) - b1*x);

s2 = sse/(n-2);

s = sqrt(s2);

sumxxbar = (x-xbar*j(n,1))`*(x-xbar*j(n,1));

t = b1/(s/sqrt(sumxxbar));

t025_51 = tinv(.975,n-2);

pt = 2*(1 - probt(t,n-2));

/******************* Part C ******************/

print 'Part C:';

upper = b1 + t025_51*s/sqrt(sumxxbar);

lower = b1 - t025_51*s/sqrt(sumxxbar);



/******************* Part D *******************/

print 'Part D:';

yhat = b0*j(n,1) + b1*x;

ssr = (yhat - ybar*j(n,1))`*(yhat - ybar*j(n,1));

sst = (y - ybar*j(n,1))`*(y - ybar*j(n,1));

r2 = ssr/sst;

r = sqrt(r2);


run;
