/******************* Problem 8.38 ******************/



data d1;

infile '\T7_3_Gasvapor.txt' firstobs = 2;
input x1 x2 x3 x4 y;
run;


proc iml;
use d1;

read all var{x1 x2 x3 x4} into xold;
read all var{y} into y;

read all var{x1} into x1;
read all var{x2} into x2;
read all var{x3} into x3;
read all var{x4} into x4;

reset print;

x = j(nrow(xold),1)||xold;

bhat = inv(x`*x)*x`*y;
s2 = (y-x*bhat)`*(y-x*bhat)/(nrow(x)-ncol(x));

covbhat = s2*inv(x`*x);

n = nrow(xold);

xc = (i(n)-(1/n)*j(n))*xold;

Sxx = xc`*xc/(n-1);

Syx = xc`*y/(n-1);

b1hat = inv(Sxx)*Syx;

ybar = y`*j(n,1)/n;

xbar = ((j(n,1))`*xold/n)`;

bnot = ybar - Syx`*inv(Sxx)*xbar;

r2 = (bhat`*x`*y - n*ybar*ybar)/(y`*y-n*ybar*ybar);

k = ncol(xold);

r2a = ((n-1)*r2 - k)/(n-k-1);

ybar = (j(n,1))`*y/n;

nybarsq = n*ybar*ybar;

bxy = bhat`*x`*y;

yy = y`*y;

diff = bxy - nybarsq;
ssr = bxy - nybarsq;
sse = yy - bxy;
k = ncol(xold);
f = (ssr/k)/(sse/(n-k-1));

pf = 1 - probf(f,k,n-k-1);


/****************** Part B ********************/

print 'Part B:';

x2x4 = x2||x4;

x11 = j(nrow(xold),1)||x2x4;

b1star = inv(x11`*x11)*x11`*y;

diff1 = b1star`*x11`*y - nybarsq;
diff2 = bxy - b1star`*x11`*y;
p = ncol(x11);
h = ncol(x) - p;
fhere = (diff2/h)/(sse/(n-k-1));

pf2_4929 = 1 - probf(2.4929,2,27);



/******************** Part C *******************/

print 'Part C:';

df = n - k - 1;
t975 = tinv(.975,df);


s = sqrt(s2);

invxpx = inv(x`*x);
b0 = bhat[1];
b1 = bhat[2];
b2 = bhat[3];
b3 = bhat[4];
b4 = bhat[5];
g00 = invxpx[1,1];
g11 = invxpx[2,2];
g22 = invxpx[3,3];
g33 = invxpx[4,4];
g44 = invxpx[5,5];

ssg1 = s*sqrt(g11);
t1 = b1/ssg1;
p1 = 2*(probt(t1,df));

ssg2 = s*sqrt(g22);
t2 = b2/ssg2;
p2 = 2*(1-probt(t2,df));

ssg3 = s*sqrt(g33);
t3 = b3/ssg3;
p3 = 2*(probt(t3,df));

ssg4 = s*sqrt(g44);
t4 = b4/ssg4;
p4 = 2*(1-probt(t4,df));


/******************** Part D ******************/

print 'Part D:';

c = {0 1 -1 0 0,
     0 0 0 1 -1,
     0 0 1 -12 0};

c1 = c[1,1:5];
c2 = c[3,1:5];
c3 = c[2,1:5];
c4 = c[1:2,1:5];

cbhat = c*bhat;

cxxc = c*inv(x`*x)*c`;

sse = y`*y - bhat`*x`*y;

p = ncol(x);

sseoverd = sse/(n-p);

q = round(trace(ginv(c)*c));

ssnum = cbhat`*inv(cxxc)*cbhat;

numc = ssnum/q;

fc = numc/sseoverd;

pfc = 1 - probf(fc,q,n-p);

/*********** H01 *************/

c1bhat = c1*bhat;

c1xxc1 = c1*inv(x`*x)*c1`;

sse = y`*y - bhat`*x`*y;

p = ncol(x);

sseoverd = sse/(n-p);

q1 = round(trace(ginv(c1)*c1));

ssnum1 = c1bhat`*inv(c1xxc1)*c1bhat;

numc1 = ssnum1/q;

fc1 = numc1/sseoverd;

pfc1 = 1 - probf(fc1,q1,n-p);


/*********** H02 *************/

c2bhat = c2*bhat;

c2xxc2 = c2*inv(x`*x)*c2`;

sse = y`*y - bhat`*x`*y;

p = ncol(x);

sseoverd = sse/(n-p);

q2 = round(trace(ginv(c2)*c2));

ssnum2 = c2bhat`*inv(c2xxc2)*c2bhat;

numc2 = ssnum2/q2;

fc2 = numc2/sseoverd;

pfc2 = 1 - probf(fc2,q2,n-p);


/*********** H03 *************/

c3bhat = c3*bhat;

c3xxc3 = c3*inv(x`*x)*c3`;

sse = y`*y - bhat`*x`*y;

p = ncol(x);

sseoverd = sse/(n-p);

q3 = round(trace(ginv(c3)*c3));

ssnum3 = c3bhat`*inv(c3xxc3)*c3bhat;

numc3 = ssnum3/q3;

fc3 = numc3/sseoverd;

pfc3 = 1 - probf(fc3,q3,n-p);


/*********** H04 *************/

c4bhat = c4*bhat;

c4xxc4 = c4*inv(x`*x)*c4`;

sse = y`*y - bhat`*x`*y;

p = ncol(x);

sseoverd = sse/(n-p);

q4 = round(trace(ginv(c4)*c4));

ssnum4 = c4bhat`*inv(c4xxc4)*c4bhat;

numc4 = ssnum4/q4;

fc4 = numc4/sseoverd;

pfc4 = 1 - probf(fc4,q4,n-p);

/******************** Part E ********************/

print 'Part E:';

print 'Using 8.47:';

print 'confidence limits';
b1me = t975*s*sqrt(g11);
b1lo = b1 - b1me;
b1up = b1 + b1me;

print 'confidence limits';
b2me = t975*s*sqrt(g22);
b2lo = b2 - b2me;
b2up = b2 + b2me;

print 'confidence limits';
b3me = t975*s*sqrt(g33);
b3lo = b3 - b3me;
b3up = b3 + b3me;

print 'confidence limits';
b4me = t975*s*sqrt(g44);
b4lo = b4 - b4me;
b4up = b4 + b4me;


print 'Using 8.67:';

thelp = 1 - .00625;


t975div = tinv(.99375,27);

print 'bonferroni confidence limits';
b1me = t975div*s*sqrt(g11);
b1lo = b1 - b1me;
b1up = b1 + b1me;

print 'bonferroni confidence limits';
b2me = t975div*s*sqrt(g22);
b2lo = b2 - b2me;
b2up = b2 + b2me;

print 'bonferroni confidence limits';
b3me = t975div*s*sqrt(g33);
b3lo = b3 - b3me;
b3up = b3 + b3me;

print 'bonferroni confidence limits';
b4me = t975div*s*sqrt(g44);
b4lo = b4 - b4me;
b4up = b4 + b4me;
