/***************** Problem 8.40 *************/

options ls = 80;

data d1;
infile '\T7_4_ChemReaction.txt' firstobs = 2;
input x1 x2 x3 y1 y2;
run;


/******************* Part A ********************/
proc iml;
use d1;

reset print;

read all var{y1} into y1;
read all var{y2} into y2;
read all var{x1 x2 x3} into xold;
read all var{x1} into x1;
read all var{x2} into x2;
read all var{x3} into x3;

y = y2;

x = j(nrow(xold),1)||xold;

bhat = inv(x`*x)*x`*y;
s2 = (y-x*bhat)`*(y-x*bhat)/(nrow(x)-ncol(x));

covbhat = s2*inv(x`*x);

n = nrow(xold);

xc = (i(n)-(1/n)*j(n))*xold;

Sxx = xc`*xc/(n-1);

Syx = xc`*y/(n-1);

b1hat = inv(Sxx)*Syx;

ybar = y`*j(n,1)/n;

xbar = ((j(n,1))`*xold/n)`;

bnot = ybar - Syx`*inv(Sxx)*xbar;

ybar = (j(n,1))`*y/n;

nybarsq = n*ybar*ybar;

bxy = bhat`*x`*y;

yy = y`*y;

diff = bxy - nybarsq;
ssr = bxy - nybarsq;
sse = yy - bxy;
k = ncol(xold);

df = n - k - 1;
t975 = tinv(.975,df);

s = sqrt(s2);

invxpx = inv(x`*x);


t975 = tinv(.975,df);

xbar = ((j(n,1))`*x/n)`;

s = s;

x0 = {1,165,32,5};

x0bhat = x0`*bhat;

invxpx = inv(x`*x);

sq = x0`*invxpx*x0;

sqrt = sqrt(x0`*invxpx*x0);

me = t975*s*sqrt;

print 'Confidence Interval:';

lo = x0bhat - me;
up = x0bhat + me;


/******************* Part B ********************/

print 'Part B:';

x0 = {1,165,32,5};

x0bhat = x0`*bhat;

invxpx = inv(x`*x);

sq = 1 + x0`*invxpx*x0;

sqrt = sqrt(1 + x0`*invxpx*x0);

me = t975*s*sqrt;

print 'Prediction Interval:';

lo = x0bhat - me;
up = x0bhat + me;


/****************** Part C **********************/

print 'Part C:';

c = {0 1 -1 0,
     0 0 2 -1};

cbhat = c*bhat;


cxxc = c*inv(x`*x)*c`;

sse = y`*y - bhat`*x`*y;

p = ncol(x);
sseoverd = sse/(n-p);


q = round(trace(ginv(c)*c));

ssnum = cbhat`*inv(cxxc)*cbhat;

numc = ssnum/q;

fc = numc/sseoverd;

pf = 1 - probf(.1577,q,n-p);
